/*
 *	Debugging
 *
 *	Author:	S.C.Merrall
 *
 *	File:	debug.h
 *
 *	Contents:	init_debug - initialise debugging
 *                      DBG_CALL   - register function entry
 *                      DBG_ARGS   - list argument values
 *                      DBG_EXIT   - register function exit
 *
 *	Description:	This supplies a concise trace system which can be
 *                      witched on and off in files by including debug_off.h
 *                      instead of debug.h
 *
 *	Change History:
 *
 *	Date   Name Comment
 *    -------- ---- -------
 *    06:02:91 SCM  Created
 *    18:02:91 SCM  Part of obejct system with naming convention
 *
 */

#include <stdio.h>

#include "constant.h"

FILE *dbg = stderr;
char *dbg_g_fname;

#ifdef __STDC__

int init_debug( char *output_filename )

#else

int init_debug( output_filename )

char *output_filename;

#endif

{
  dbg = fopen(output_filename, "w");

  if (dbg == NULL) return FAIL;

  return SUCCESS;

}
