/*
 *	Plurals
 *
 *	Author:	S.C.Merrall
 *
 *	File:	mp_type.h
 *
 *	Contents:	cons_cell
 *
 *	Description:	Type definitions for lisp types where appropriate
 *
 *	Change History:
 *
 *	Date   Name Comment
 *    -------- ---- -------
 *    23:04:91 SCM  Created
 *    16:05:91 SCM  Constants pulled from consant.h
 *    22:05:91 SCM  typedef of cons_cell moved into mp_lists.m
 *    04:06:91 SCM  Changed sizes to bytes and added alignment defs
 *    29:01:92 SCM  GC_MOVED is no longer treated as a type
 *
 */

#define NUMBER_OF_TYPES 6

/*#define NIL (natural)0x7FFF*/

#define INTEGER 1
#define INTEGER_SIZE (sizeof(int))
#define INTEGER_ALIGN (sizeof(int))

#define MP_CONS 2
#define MP_CONS_SIZE (2*sizeof(natural))
#define MP_CONS_ALIGN (sizeof(natural))

#define MP_VECTOR 3
#define MP_VECTOR_SIZE (sizeof(natural))
#define MP_VECTOR_ALIGN (sizeof(natural))

#define MP_FLOAT 4
#define MP_FLOAT_SIZE (sizeof(float))
#define MP_FLOAT_ALIGN (sizeof(float))

#define MP_SYMBOL 5
#define MP_SYMBOL_SIZE (sizeof(char *))
#define MP_SYMBOL_ALIGN (sizeof(char *))

#define MP_SPECIAL 6

/*  #define GC_MOVED 6 */

#define MP_LENGTH(bytes) ((bytes)/sizeof(natural))

