/*
 * MPL Extension
 *
 * Author:        S.C.Merrall
 *
 * File:        seq_net.h
 *
 * Contents:     seq_next
 *               seq_prev
 *
 * Description:    This file contains a set of macros
 *              which are built on top of the Xnet functions
 *              in the same way that the non wrap version of
 *              the Xnet are as supplied in the mpl documentation.
 *              seq_prev accesses the previous PE in iproc numbers and
 *              seq_next accesses the next. 0 is returned for the edge
 *              cases
 *
 * Change History:
 *
 *   Date   Name Comment
 * -------- ---- -------
 * 07:02:91 SCM  Created
 * 20:01:91 SCM  Modified to work with paired processors
 *
 */

#define seq_prev(val) ((PP_iproc==0)                       \
		       ? 0				   \
		       : (PP_xnetW(1).((PP_ixproc!=PP_nxproc) \
				    ? val		   \
				    : (PP_xnetN(1).val))))


/*  #define seq_prev(val) ((iproc == 0) ? 0 : ((ixproc == 0) ? xnetNW[1].val \
 *                                                          : xnetW[1].val))
 */

#define seq_next(val) ((PP_iproc==PP_nproc)             \
		       ? 0				\
		       : (PP_xnetE(1).((PP_ixproc!=0)	\
				    ? val		\
				    : (PP_xnetS(1).val))))

/*  #define seq_next(val) ((iproc == nproc-1) ? 0 \
 *                                            : ((ixproc == nxproc-1) \
 *                                                ? xnetSE[1].val \
 *                                                : xnetE[1].val))
 */

